﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;

using Windows.UI.Xaml.Media;

using Windows.Data.Xml.Dom;
using Windows.UI.Notifications;

namespace Kolory
{
    partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();

            Color kolor = (Rectangle1.Fill as SolidColorBrush).Color;
            SliderR.Value = kolor.R;
            SliderG.Value = kolor.G;
            SliderB.Value = kolor.B;
            SliderA.Value = kolor.A;

            zmienWygladKafelka(kolor);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //App.Current.Exit();
            Window.Current.Close();
        }

        private static string SkładoweKoloruDec(Color kolor)
        {
            return "R=" + kolor.R.ToString() + ", G=" + kolor.G.ToString() + ", B=" + kolor.B.ToString() + ", A=" + kolor.A.ToString();
        }

        private static string SkładoweKoloruHex(Color kolor)
        {
            return "#" + kolor.R.ToString("X") + kolor.G.ToString("X") + kolor.B.ToString("X");
        }

        private void Sliders_ValueChanged(object sender, RoutedPropertyChangedEventArgs e)
        {
            Color kolor = new Color()
            {
                R = (byte)SliderR.Value,
                G = (byte)SliderG.Value,
                B = (byte)SliderB.Value,
                A = (byte)SliderA.Value
            };
            (Rectangle1.Fill as SolidColorBrush).Color = kolor;

            TextBlock1.Text = SkładoweKoloruDec(kolor) + "\n";
            TextBlock1.Text += "HEX: " + SkładoweKoloruHex(kolor);

            zmienWygladKafelka(kolor);          
        }

        TileUpdater tu = TileUpdateManager.CreateTileUpdaterForApplication();

        public void zmienWygladKafelka(Color kolor)
        {
            XmlDocument xml = TileUpdateManager.GetTemplateContent(TileTemplateType.TileWideText01);
            IXmlNode wezelTekst = xml.GetElementsByTagName("text").First();            
            wezelTekst.AppendChild(xml.CreateTextNode("Kolory:"));
            wezelTekst = xml.GetElementsByTagName("text").Item(1);
            wezelTekst.AppendChild(xml.CreateTextNode(SkładoweKoloruDec(kolor)));
            wezelTekst = xml.GetElementsByTagName("text").Item(2);
            wezelTekst.AppendChild(xml.CreateTextNode("HEX: " + SkładoweKoloruHex(kolor)));
            tu.Update(new TileNotification(xml));
        }

        public void zmienWygladKafelkaZObrazem(Color kolor)
        {
            XmlDocument xml = TileUpdateManager.GetTemplateContent(TileTemplateType.TileWideImageAndText);
            IXmlNode wezelTekst = xml.GetElementsByTagName("text").First();
            wezelTekst.AppendChild(xml.CreateTextNode(SkładoweKoloruDec(kolor)));

            XmlElement elementObraz = xml.GetElementsByTagName("image").First() as XmlElement;
            elementObraz.SetAttribute("src", "package://images\\WideLogo.png");
            elementObraz.SetAttribute("alt", SkładoweKoloruHex(kolor));

            tu.Update(new TileNotification(xml));
        }
    }
}
